//? cpmuc.cpp
//? C+- by Ulrich Mutze. Status of work 2022-05-06.
//? Copyright (c) 2022 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//?
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//?
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for
//? more details.


#include <cpmuc.h>   // see for explanations

bool CpmArrays::UseCount::reattach_(UseCount const& u)
{
   ++*u.p_;
      // no conflict with constantness of u !!
      // count of u becomes incremented whereas in the next statement
      // the count of *this becomes decremented
 //  if (--*p_==0){     // --p==0 in Koenig's book, works but is weird syntax
   if (--p_==nullptr){
      delete p_;
      p_=u.p_;
      return true;
   }
   else{
      p_=u.p_;
      return false;
   }
}
