//? cpmdigraph.cpp
//? C+- by Ulrich Mutze. Status of work 2022-05-06.
//? Copyright (c) 2022 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#include <cpmdigraph.h>

namespace CpmGeo{
   using namespace CpmRoot;
   using namespace CpmLinAlg;
   using CpmArrays::Vo;

   bool close(Z2 a, Z2 b)
   {
      R r=(a-b).abs();
      return( r>0.5 && r<1.5);
   }

   bool rimRelated(Z2 a, Z2 b, Z rim)
   {
      return (a.x1==0 && b.x1==(rim-1))||(a.x1==(rim-1) && b.x1==0);
   }


   S<Z> shiftNegFunc(S<Z> const& s, Z const& n)
   {
      Vo<Z> a=s.toV();
      for (Z i=1;i<=a.dim();++i) a[i]+=n;
      return S<Z>(a);
   }


} // namespace

