//? cpmforces.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_FORCES_H_
#define CPM_FORCES_H_
/*

   Description: classes for sources of forces and related physical
   quantities. Here the decision is made whether geometry is treated
   in 2 dimensions or three dimensions (2-dimensional case i.e.
   cpmdim2.h, cpmdim2.cpp not yet available)
   See also cpmforcesx.h
*/

#include <cpmconstphys.h>
#include <cpmfield.h>
#include <cpmproperties.h>
#include <cpmdim.h>
#include <cpmcamera.h>
#include <cpmdimdef.h>

#if defined(CPM_DIMDEF2)

#define CPM_DIM CpmDim2
#define CPM_CAMERA CpmCamera2
#define CPM_PHYSICS CpmPhysics2

namespace CPM_PHYSICS{
   #include <cpmforcesx.h>
}

#undef CPM_DIM
#undef CPM_CAMERA
#undef CPM_PHYSICS

#endif

////////////////////////////////////////////////////////////////////////
#if defined(CPM_DIMDEF3)

#define CPM_DIM CpmDim3
#define CPM_CAMERA CpmCamera3
#define CPM_PHYSICS CpmPhysics3

namespace CPM_PHYSICS{
   #include <cpmforcesx.h>
}

#undef CPM_DIM
#undef CPM_CAMERA
#undef CPM_PHYSICS

#endif

#endif
