//? cpmparofspc.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_PAROFSPC_H_
#define CPM_PAROFSPC_H_
/*
    Description: Describing a partition of space into
    subsets in a way to help parallel computing, where
    a process is linked to one such subset.
*/
#include <cpmdim.h>
#include <cpmshapes.h>
#include <cpmangle.h>
#include <cpmlinalg.h>
#include <cpmfr.h>
#include <cpmrecord.h>
#include <cpmframe.h>
#include <cpmgroupgraph.h>
#include <cpmdimdef.h>
#include <cpmalgorithms.h>
#include <cpmmini.h>
#include <cpmvectormore.h>
#include <cpmforces.h>
#include <cpmimagingtools.h>

#if defined(CPM_DIMDEF2)
#define CPM_PHYSICS CpmPhysics2
#define CPM_CAMERA CpmCamera2
#define CPM_DIM CpmDim2

namespace CPM_DIM{
   #include <cpmparofspcx.h>
}

#undef CPM_PHYSICS 
#undef CPM_CAMERA
#undef CPM_DIM

#endif

////////////////////////////////////////////////////////////////////////

#if defined(CPM_DIMDEF3)
#define CPM_PHYSICS CpmPhysics3
#define CPM_CAMERA CpmCamera3
#define CPM_DIM CpmDim3

namespace CPM_DIM{
   #include <cpmparofspcx.h>
}

#undef CPM_PHYSICS 
#undef CPM_CAMERA
#undef CPM_DIM

#endif

#endif // guard
