//? cpmsys2aps.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


// There was a Sys1 first, which now is obsolete.
// Implementation of Sys2Appl is essentially the implementation of 
// Sys2Appl::doTheWork(). This happens essentially in cpmsys2apscpp.h.
// The interesting class from a physics point of view is Sys2.

#include <cpminifilebasapp.h>
#include <cpmsys2.h>

using CpmRoot::Word;
using CpmApplication::IniFileBasedApplication;

#if defined(CPM_DIMDEF2)
namespace CpmPala2_2{
 
///////////////// CpmPala2_2::Sys2Appl ///////////////////////////////////

class Sys2Appl: public IniFileBasedApplication { 
// Sys2 application 2D

public:
   Sys2Appl(const Word& w):IniFileBasedApplication(w)
   {
      cpmmessage("CpmPala2_2::Sys2Appl("&w&") done");
   }
   void doTheWork();
};

} // CpmPala2
#endif

#if defined(CPM_DIMDEF3)
namespace CpmPala2_3{

//////////////// CpmPala2_3::Sys2Appl ////////////////////////////////////

class Sys2Appl: public IniFileBasedApplication {
// Sys2 application 3D

public:
   Sys2Appl(const Word& w):IniFileBasedApplication(w)
   {
      cpmmessage("CpmPala2_3::Sys2Appl("&w&") done");
   }
   void doTheWork();
};

} // CpmPala3
#endif
