//? cpmsysviewer.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_SYSVIEWER_H_
#define CPM_SYSVIEWER_H_

#include <cpminifilebasapp.h>
#include <cpmimagingtools.h>
#include <cpmcamera.h>

namespace CpmPalaAux{

////////////////////// ViewerAppl ///////////////////////////

   using CpmApplication::IniFileBasedApplication;
   using namespace CpmRoot;
   using namespace CpmRootX;
   using namespace CpmImaging;
   using namespace CpmArrays;
   
class SysViewerAppl:public IniFileBasedApplication{// viewer application

   V<CpmCamera2::Camera> ca2_;
   V<CpmCamera3::Camera> ca3_;
   ShowControl sc_;

public:
   SysViewerAppl(Word const& w);
   V<Z> showMovie2();
   V<Z> showMovie3();
   void doTheWork();
      // calling showMovie in a suitable context
};
} // CpmPalaAux
#endif
