//? cpmsysviewercpp.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


/*
   cpmsysviewercpp.h
   code for inclusion into different namespace contexts.
   Common definition of the functions SysViewerAppl::showMovie2
   and SysViewerAppl::showMovie3
*/

   CPM_MA
   Frame frv;
   frv.paint(LIGHTGREEN);
   frv.vis();
  // Record rc=rch.getRecord();
   Z nca=ca.dim();
   Z nfn=inFiles.dim();
   if (nca!=nfn) 
      cpmerror("showMovie(V<Camera>,V<Word>,Z ): dimension mismatch");

   Z i;
   cpmmessage(mL,"Number of movies shown simultaneously: "&cpm(nfn));
   V<ExtrSys2> extr(nfn);
   // Notice that cpmsys2x.h made the definition
   // typedef ParExt<ParCT,ParVT,ParT,ExtSys,Sys2Base> ExtrSys2;
   // and also gives definitions of ParCT, ParVT, and ParT.
   cpmmessage(loc&" initializing Extr started");
   for (i=1;i<=nfn;i++){
      Word ifi=Message::ext(inFiles[i]);
  //    Word ofi=Message::ext(outFiles[i]);
      cpmdebug(ifi);
    //  cpmdebug(ofi);
      extr[i]=ExtrSys2(ifi);
   }
   cpmmessage(mL,loc&" initializing Extr done");

   V<ShowControl> shco(nfn,sc_);
   for (i=1;i<=nfn;i++) shco[i].imgFile=inFiles[i];
   V<Z> count(nfn);
   bool b=true;
   while(b){
      // reading from file
      for (i=1;i<=nfn;i++){
         b=extr[i].next();
         if (b==false) break;
         count[i]=extr[i].getCount();
      }
      if (b==false) break;
      // showing the result
      for (i=1;i<=nfn;i++){
         extr[i].show(ca[i],shco[i]);
            // this is the essential graphical activity
            // see cpmextractorx.h for definition
         bool bi=extr[i].isVal();
         if (bi==false) b=false;
      }
   }
   CPM_MZ;
   return count;
