//? cpmur.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_UR_H_
#define CPM_UR_H_
/*
Description: experiment on something like cellular automata
   No experience. Experimental.

*/

#include <cpmtypes.h>
#include <cpmv.h>

namespace CpmPhysics{

   using namespace CpmRoot;
   using namespace CpmSystem;

   using CpmRoot2::R1;
   using CpmArrays::V;
   using CpmArrays::M;

template <class X, class Y>
class Ur{
public:
   Ur(){}
   Ur(const X& xI):x(xI){} 
   X loc()const{ return x;}
   R getAge()const{ return t;}
   V<Ur<X> > create(const Ur<X>& u);
   void shift(const Y& s){x+=s;}
   void age(R dt){t+=dt;}
private:
   R1 t;
   X x;
};

template <class X, class Y>
class UrSys{
private: 
   V< Ur<X,Y> > vu;
   M<X,Ur<X,Y> > mxu;
public:
   void age(R dt);

};


template <class X, class Y>
void UrSys<X,Y>::age(R dt)
{
   Z n=vu.dim(),i;
   for (i=1;i<=n;i++) vu[i].age(dt);
}


} // namespace

#endif

