//? vqm2app1.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef VQM2APPL1_H_
#define VQM2APPL1_H_
/**********************************************************
*   Author: Ulrich Mutze                                  *
*   Copyright (c) 2001 Ulrich Mutze                       *
*   All rights reserved                                   *
*                                                         *
***********************************************************

/*******************************************************************
   vqm2app1.h

   Description: collection application classes. Here for the
      VQM2-program. Can be used as a pattern for moderately
      complex programs. This is not representative for my most complex
      program organisation (which is used in my PaLa program and which
      makes use of my Task construct). See the file vqm2.h and vqm2.cpp
      for bringing these classes together.

   History: origin and long standing usage undocumented.
      2007-04-28: statement setTitle("app*"); added to all constructor
      implementations.

********************************************************************/
#include <cpminifilebasapp.h>

namespace CpmVQM2{

using CpmArrays::V;
using CpmRoot::Word;
using CpmApplication::IniFileBasedApplication;

class App1: public IniFileBasedApplication {
public:
   App1(const Word& w):
      IniFileBasedApplication(w){setTitle("app1");}
   void doTheWork();
};

class App2: public IniFileBasedApplication {
public:
   App2(const Word& w):
      IniFileBasedApplication(w){setTitle("app2");}
   void doTheWork();
};

class App3: public IniFileBasedApplication {
public:
   App3(const Word& w):
      IniFileBasedApplication(w){setTitle("app3");}
   void doTheWork();
};

class App4: public IniFileBasedApplication {
public:
   App4(const Word& w):
      IniFileBasedApplication(w){setTitle("app4");
      cpmcerr<<"App4() done"<<std::endl;}
   void doTheWork();
};

class App4b: public IniFileBasedApplication {
public:
   App4b(const Word& w):
      IniFileBasedApplication(w){setTitle("app4b");}
   void doTheWork();
};

class App4c: public IniFileBasedApplication {
public:
   App4c(const Word& w):
      IniFileBasedApplication(w){setTitle("app4c");}
   void doTheWork();
};

class App5: public IniFileBasedApplication {
public:
   App5(const Word& w):
      IniFileBasedApplication(w){setTitle("app5");}
   void doTheWork();
};

class App6: public IniFileBasedApplication {
public:
   App6(const Word& w):
      IniFileBasedApplication(w){setTitle("app6");}
   void doTheWork();
};

class App6b: public IniFileBasedApplication {
public:
   App6b(const Word& w):
      IniFileBasedApplication(w){setTitle("app6b");}
   void doTheWork();
};

class App7: public IniFileBasedApplication {
public:
   App7(const Word& w):
      IniFileBasedApplication(w){setTitle("app7");}
   void doTheWork();
};

class App8: public IniFileBasedApplication {
public:
   App8(const Word& w):
      IniFileBasedApplication(w){setTitle("app8");}
   void doTheWork();
};

class App9: public IniFileBasedApplication {
public:
   App9(const Word& w):
      IniFileBasedApplication(w){setTitle("app9");}
   void doTheWork();
};

class App10: public IniFileBasedApplication {
public:
   App10(const Word& w):
      IniFileBasedApplication(w){setTitle("app10");}
   void doTheWork();
};

} // namespace

#endif
