//? vqm2app3.h
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//?
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//?
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for
//? more details.


#ifndef VQM2APPL3_H_
#define VQM2APPL3_H_

/*******************************************************************
   vqm2app3.h

   Description: collection application classes. Here for the
      VQM2-program. Can be used as a pattern for moderately
      complex programs. This is not representative for my most complex
      program organisation (which is used in my PaLa program and which
      makes use of my Task construct). See the file vqm2.h and vqm2.cpp
      for bringing these classes together.
********************************************************************/
#include <cpminifilebasapp.h>

namespace CpmVQM2{

using CpmArrays::V;
using CpmRoot::Word;
using CpmApplication::IniFileBasedApplication;

class App17: public IniFileBasedApplication {
public:
   App17(const Word& w):
      IniFileBasedApplication(w){setTitle("app17");}
   void doTheWork();
};

class App18: public IniFileBasedApplication {
public:
   App18(const Word& w):
      IniFileBasedApplication(w){setTitle("app18");}
   void doTheWork();
};

class App18x: public IniFileBasedApplication {
public:
   App18x(const Word& w):
      IniFileBasedApplication(w){setTitle("app18x");}
   void doTheWork();
};

class App18a: public IniFileBasedApplication {
public:
   App18a(const Word& w):
      IniFileBasedApplication(w){setTitle("app18a");}
   void doTheWork();
};

class App18b: public IniFileBasedApplication {
public:
   App18b(const Word& w):
      IniFileBasedApplication(w){setTitle("app18b");}
   void doTheWork();
};

class App19: public IniFileBasedApplication {
public:
   App19(const Word& w):
      IniFileBasedApplication(w){setTitle("app19");}
   void doTheWork();
};

class App20: public IniFileBasedApplication {
public:
   App20(const Word& w):
      IniFileBasedApplication(w){setTitle("app20");}
   void doTheWork();
};

} // namespace

#endif
