//? vqm2.cpp
//? C+- by Ulrich Mutze. Status of work 2022-03-21.
//? Copyright (c) 2020 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


/************************************************************************
   vqm2.cpp

   Author: Ulrich Mutze
   Description: 'Visual Quantum Mechanics'
      // Version of the program that comes close in
      // structure to the myexcel2 program which seems to
      // be a practical compromise between flexibility and
      // transparency of structure
   History:
************************************************************************/

#include <vqm2app1.h>
#include <vqm2app2.h>
#include <vqm2app3.h>
#include <vqm2.h>

using namespace CpmRoot;
using namespace CpmSystem;
using namespace CpmApplication;
using namespace CpmVQM2;

Z CpmApplication::main_(void)
// main program from a functional point of view. The actual basic
// application main(), or some Windows equivalent, is presently defined
// cpmapplication.cpp.
{
   cpmmessage("main_() Begin");
   cpmverbose=2;
   using namespace CpmApplication;
   title_="vqm2";
   Z sel = args_.valInd(2) ? args_[2].toZ() : 1;
   cpmverbose = args_.valInd(3) ? args_[3].toZ() : 2;
   R tWait = args_.valInd(4) ? args_[4].toR() : R(1);
   cpmmessage("sel="&cpmwrite(sel));
   cpmmessage("cpmverbose="&cpmwrite(cpmverbose));
   Z nn=namList.dim();
 //  cout<<"namList.dim() = "<<nn<<endl;
 //  cout<<"namList:"<<namList<<endl;
   if (sel<1) cpmerror("main_(): sel<1");
   else if (sel>nn){
      cpmmessage("nothing done");
      cpmwait(2);
   }
   else appList[sel]();
      // this calls the selected program
   cpmwait(tWait);
   cpmmessage("main_() End");
   return 0;
}
